import Acquisition
import AccessControl
import OFS
from Globals import HTMLFile, MessageDialog, Persistent
from DocumentTemplate.DT_Util import *
from DocumentTemplate.DT_String import String

from ImapMailbox import ImapMailbox

class ImapClient(
	OFS.Folder.Folder
	):
	'''
	Imap Client
	'''

	name='ImapClient'
	id='ImapClient'
	icon='misc_/ImapClient/Main'
	meta_type='ImapClient'

        _properties = (
                {'id':'title','type':'string','mode':'w'},
                )

	all_meta_types      = (
        	{'name': 'Mailbox', 'action': 'manage_addImapMailboxForm'},
                    )
	

	__ac_permissions__=(
		('View management screens',('manage_tabs','manage_main')),
		('Change permissions',('manage_access',)),
		('Change ImapClient',('manage_edit',),('Manager',)),
		)

	def __init__(self,id='ImapClient',title='ImapClient'):
		self.id = id
		self.title = title

	def manage_edit(self,title,REQUEST=None):
		"""edit ImapClient"""
		self.title=title
		if REQUEST is not None:
			return MessageDialog(
				title='Edited',
				message='<strong>%s</strong> has been edited.' % self.id,
				action = './manage_main'
				)


	def manage_addMailbox(self,host,username,password,userfolder):
		pass
	
	
	
	
	

addImapClientForm=HTMLFile('manage/addClient',globals())

def addImapClient(self,id,title,REQUEST=None):
	"""Create a ImapClient and install it in its parent Folder
	The argument 'self' will be bound to the parent Folder.
	"""

	handle=ImapClient(id,title)
	handle.id=id
	handle.title=title
	self._setObject(id,handle)
	if REQUEST is not None:
		return self.manage_main(self, REQUEST)

addImapMailboxForm=HTMLFile('manage/addMailbox',globals())

def addImapMailbox(self,id,title,username,password,host='localhost',userfolder='INBOX.',REQUEST=None):
	"""Create a ImapRootFolder and install it in its parent Folder
	The argument 'self' will be bound to the parent Folder.
	"""

	handle=ImapMailbox(id,title,username,password,host,userfolder)
	self._setObject(id,handle)
	handle = self._getOb(id,None)
	if not handle:
		raise 'CreateError', 'Could not create object'
	handle._updateImapFolders()
	if REQUEST is not None:
		return self.manage_main(self, REQUEST)

